*
* Quick Report Header File
*
*
#define DEFAULT_FONT	"Arial Narrow"
#define DEFAULT_SIZE	9
#define DEFAULT_STYLE	"N"

#define TITLE_FONT		"Arial Narrow"
#define TITLE_SIZE		12
#define TITLE_STYLE		"B"

#define SUBTITLE_FONT	"Arial Narrow"
#define SUBTITLE_SIZE	10
#define SUBTITLE_STYLE	"B"

#define RULER_INCHES	1
#define RULER_METRIC	2
#define RULER_PIXEL		3
#define RULER_FOXEL		4

#define MODE_OPAQUE		0
#define MODE_TRANS		1

*!*	1	Report
*!*	2	Workarea
*!*	3	Index
*!*	4	Relation
*!*	5	Text
*!*	6	Line
*!*	7	Box
*!*	8	Repfield
*!*	9	Bandinfo
*!*	10	Group
*!*	17	Picture
*!*	18	Variable
*!*	21	Printer Driver Setup
*!*	25	Data Environment
*!*	26	Cursor Object

#define OBJTYPE_REPORT		1
#define OBJTYPE_WORKAREA	2
#define OBJTYPE_TEXT		5
#define OBJTYPE_LINE		6
#define OBJTYPE_BOX			7
#define OBJTYPE_EXPR		8
#define OBJTYPE_BAND		9
#define OBJTYPE_GROUP		10
#define OBJTYPE_PICTURE		17
#define OBJTYPE_VARIABLE	18
#define PBJTYPE_PRINTER		21

#define OBJTYPE_ENV			25
#define OBJTYPE_CURSOR		26

#define OBJCODE_REPORT		53
* OBJCODE field values for BAND
* Other codes applies to Group Header/Footer, Column Header/Footer

#define BAND_TITLE		0
#define BAND_HEADER		1
#define BAND_DETAIL		4
#define BAND_FOOTER		7
#define BAND_SUMMARY	8

#define BAND_HEIGHT		2000 && Height Of Band divider in Report Designer

#define PEN_HAIRLINE	0
#define PEN_NORMAL		1

#define PEN_PATTERN		8

#define TOTAL_NONE		0
#define TOTAL_CNT		1		
#define TOTAL_SUM		2
#define TOTAL_AVG		3
#define TOTAL_MIN		4
#define TOTAL_MAX		5
#define TOTAL_STD		6
#define TOTAL_VAR		7

* Paper width in Pixels for printer HP LaserJet 1100
* 
* for portrait - 747
* for landscape - 1082

#define PORT_WIDTH		747
#define LAND_WIDTH		1082

#define PAGE_PORTRAIT		0
#define PAGE_LANDSCAPE		1
#define PAGE_AUTOMATIC		2

#define LINE_AT_TOP			0
#define LINE_AT_BOTTOM		1

#define COLUMN_SEPARATOR	3

#define ACTION_PRINT		0
#define ACTION_PREVIEW		1
#define ACTION_MODIFY		2

#define CRLF	chr(13)+chr(10)
