*
*  PlugIns
*
*   .. 2000
* 30.11.2000 09:55
* 	 
*		-  PlugIn BOOT.INF
*		-  PlugIn CONFIG.INI
*		-  prg, app, exe  _PLUGIN
*			       PlugIn( ROOT_OBJECT )
*			
*
#include include/main.h
#define PLUGIN_ENTRYPOINT	"PlugIn"

Parameter m.App
if not vartype(m.App)=T_OBJECT
	Return .F.
endif

Private m.OnError, m.nError, m.Global

m.OnError=ON("ERROR")
m.nError=0

On Error Store Error() to m.nError

m.Global=.T.
PlugInFromINIFiles()
m.Global=.F.
PlugInFromINIFiles()

PlugInFromDir()

On Error &OnError

Procedure PlugInFromDir
Local plg[1],i,j,k,l,n,o,p,s
Local m.CommandLine, m.Class, m.ClassLib, m.ClassApp
if empty(_PlugIns) 	
	*   
	Return .F.
endif
if addbs(_Plugins)='.\'	 
	*   - 
	Return .F.
endif

Dimension PLG[1]
k=ADIR(PLG,addbs(_PlugIns)+"*.*")
for i=1 to k
	if INLIST(JustExt(plg[i,1]),'PRG','APP','EXE')
		s=AddBS(_PlugIns)+plg[i,1]
		do (PLUGIN_ENTRYPOINT) in (s) with (m.app)
	endif
next

Procedure PlugInFromINIFiles
Local plg[1],i,j,k,l,n,o,p,s
Local m.CommandLine, m.Class, m.ClassLib, m.ClassApp

Dimension PLG[1]

if GetSection(@PLG)=0 && NoErrors
	for i=1 to alen(PLG,1)
		s=GetEntry(plg[i])
		if not empty(s)
			if GetWordCount(s,';')>1
				m.Class=GetWordNum(s,1,';')
				m.ClassLib=GetWordNum(s,2,';')
				m.ClassApp=GetWordNum(s,3,';')

				m.App.NewObject(plg[i],m.Class,m.ClassLib,m.ClassApp)
			else
				m.CommandLine=s
				do (PLUGIN_ENTRYPOINT) in (m.CommandLine) with (m.App)
			endif
		endif
	next
endif

Procedure GetSection(aDim)
if m.Global
	Return GetGlobalSection(@aDim,PLUGIN_SECTION)
else
	Return GetLocalSection(@aDim,PLUGIN_SECTION)
endif

Procedure GetEntry( m.Value )
if m.Global
	Return GetGlobalProfile(PLUGIN_SECTION,m.Value,"")
else
	Return GetLocalProfile(PLUGIN_SECTION,m.Value,"")
endif
	
