*      
*
* RegWrite
*
#include reg.h

lParameters m.cParam, m.xValue, m.lBinary

DECLARE Integer RegOpenKey IN Win32API ;
		Integer nHKey, String @cSubKey, Integer @nResult

DECLARE Integer RegCloseKey IN Win32API ;
		Integer nHKey

DECLARE Integer RegCreateKey IN Win32API ;
		Integer nHKey, String @cSubKey, Integer @nResult

DECLARE Integer RegSetValueEx IN Win32API ;
		Integer hKey, String lpszValueName, Integer dwReserved,;
		Integer fdwType, String lpbData, Integer cbData


Local nKey,cKey,cDeired, ntype, buf, buflen, ret, cString

nKey=0
cKey=Substr(m.cParam,1,At('\',m.cParam)-1)
Ret=.F.
do case
Case cKey='HKCR'
	nKey=HKEY_CLASSES_ROOT
Case cKey='HKCU'
	nKey=HKEY_CURRENT_USER
Case cKey='HKLM'
	nKey=HKEY_LOCAL_MACHINE
Case cKey='HKU'
	nKey=HKEY_USERS
Case cKey='HKCC'
	nKey=HKEY_CURRENT_CONFIG
Otherwise
	Return Ret
EndCase
cString=Substr(m.cParam,Len(cKey)+2)
hKey=0
If RegOpenKey( nKey, @cString, @hKey ) = 0
	cValue=""
Else
	cValue=SubStr(cString,Rat('\',cString)+1)
	cString=Substr(cString,1,Rat('\',cString)-1)
	If RegOpenKey( nKey, @cString, @hKey ) # 0
		If RegCreateKey(nKey,@cString,@hKey) # 0
			Return Ret
		endif
	endif
endif

If not Empty(hKey)
	do case
	Case Vartype(m.xValue)='I'
		ntype=REG_DWORD
		buf=B2C(m.xValue,4)
	Case InList(Vartype(m.xValue),'N','F','B')
		If Mod(m.xValue,1)=0 and ;
		(Between(m.xValue,0,0xFFFFFFFF) or Between( m.xValue,-0x7FFFFFFF,0x7FFFFFF))

			ntype=REG_DWORD
			buf=B2C(m.xValue,4)

		Else
			ntype=REG_SZ
			buf=Transform(m.xValue)
		endif

	Case Vartype(m.xValue)='Y'
		ntype=REG_SZ
		buf=Transform(m.xValue)
	Case InList(Vartype(m.xValue),'D','T')
		ntype=REG_SZ
		buf=Transform(m.xValue)
	Case InList(Vartype(m.xValue),'L')
		ntype=REG_DWORD
		buf=B2C(Iif(m.xValue,1,0),4)
	Otherwise
		If not Empty(lBinary)
			ntype=REG_BINARY
		Else
			ntype=REG_SZ
		EndIf 
		buf=m.xValue
	EndCAse		

	buflen=Len(buf)
	Ret=RegSetValueEx(hKey,cValue,0,nType,buf,buflen)=0

	RegCloseKey(hKey)

endif
Return Ret
	
Procedure B2C
lparameter m.Val,m.Len
local i, m.Ret
m.Ret=""
do while m.Val # 0
	m.Ret=m.Ret+Chr(Mod(m.Val,256))
	m.Val=BitRShift(m.Val,8)
enddo
Return iif(empty(m.Len),m.Ret,Padr(m.Ret,m.Len,chr(0)))
