*:********************************************************************
*:
*: Procedure file :face.prg
*:
*: Contents :
*: 
*: 		Class     InterFace AS Custom
*: 
*: 		Class     Face AS Custom
*: 
*: 		Class     ToolBarButton AS CommandButton
*: 
*: 		Class     MyToolBar AS ToolBar
*: 
*: 		Class     MySep AS Separator
*:
*: (c) Piva, BEAR v.43 on 25.04.2003 09:44
*:********************************************************************
*
*   Interface
*    -   ...
*
*   .. 2003, piva@kurgan.isp.ru
* 15:00, 17  2003 .
*

#include include/main.h

oKernel.AddObject("InterFace","InterFace")	
With oKernel.Interface
	
	***** File
	
	.Add(F_PAD,"PadFile","_MSYSMENU","\<","Alt+A",,,", , ,      ")
	.Add(F_POP,"File","PadFile")
	
	.Add(F_BAR,"New","File","\<","F2",OP_NEW,IMG_NEW,"  ",1,FACE_FREE)
	.Add(F_BAR,"Open","File","\<","F3",OP_OPEN,IMG_OPEN,"  ",1,FACE_VIEW)
	.Add(F_BAR,"Save","File","\<","Ctrl+S",OP_SAVE,IMG_SAVE,"   ",1,FACE_DOCUMENT)
	
	.Add(F_BAR,"FSP1","File","\-",,_MFI_SP100,,,1)
	
	.Add(F_BAR,"Delete","File","\<","F8",OP_DELETE,IMG_DELETE,"  ",0,FACE_VIEW)
	
	.Add(F_BAR,"FSP2","File","\-",,_MFI_SP200,,,)
	
	.Add(F_BAR,"List","File","\< ","F4",OP_LIST,IMG_LIST,"  ",1,FACE_FREE)
	
	.Add(F_BAR,"FSP3","File","\-",,_MFI_SP300,,,1)
	
	.Add(F_BAR,"PrintSetup","File"," ",,OP_PRINTSETUP,IMG_PRTSETUP,"  ",,FACE_FREE)
	.Add(F_BAR,"Print","File","\<","F5",OP_PRINT,IMG_PRINT,"    ",1,FACE_PRINT)
	.Add(F_BAR,"Preview","File"," ","Shift+F5",OP_PREVIEW,IMG_PREVIEW,"      ",1,FACE_PRINT)
	.Add(F_BAR,"PrintModify","File","  ","Ctrl+F5",OP_PRINTMODIFY,IMG_MODIFY,"  ",0,FACE_PRINT)
	
	.Add(F_BAR,"FSP4","File","\-",,_MFI_SP400,,,1)
	
	.Add(F_BAR,"Quit","File","\<","F12",OP_QUIT,IMG_QUIT,"  ")
	
	***** Edit
	
	.Add(F_PAD,"PadEdit","_MSYSMENU","\<","Alt+G",,,"    ")
	.Add(F_POP,"_MEDIT","PadEdit")
	
	.Add(F_BAR,"Copy","_MEdit","\<","Ctrl+C",_MED_COPY,IMG_COPY,"  ",0)
	.Add(F_BAR,"Paste","_MEdit","\<","Ctrl+V",_MED_PASTE,IMG_PASTE,"  ",0)
	.Add(F_BAR,"Cut","_MEdit","\<","Ctrl+X",_MED_CUT,IMG_CUT,"  ",0)
	.Add(F_BAR,"ESP1","_MEdit","\-",,_MED_SP100,,,0)
	.Add(F_BAR,"Undo","_MEdit","\<","Ctrl+U",_MED_UNDO,IMG_UNDO,"  ",0)
	.Add(F_BAR,"ESP2","_MEdit","\-",,_MED_SP200,,,0)
	.Add(F_BAR,"SelectAll","_MEdit"," ","Ctrl+A",_MED_SLCTA,_MED_SLCTA,"   ")
	.Add(F_BAR,"ESP3","_MEdit","\-",,_MED_SP300,,,1)
	.Add(F_BAR,"Find","_MEdit","","Ctrl+F","DO MYFIND",IMG_FIND,"  ",1,FACE_VIEW)
	
	***** View
	
	.Add(F_PAD,"PadView","_MSYSMENU","\<","Alt+L",,,"  ")
	.Add(F_POP,"View","PadView")
	
	***** Service
	
	.Add(F_PAD,"PadService","_MSYSMENU","\<","Alt+C",,,"  ")
	.Add(F_POP,"Service","PadService")
	
	.Add(F_BAR,"ToExcel","Service","  Excel","","Do ToExcel",IMG_EXCEL,"   Excel",1,FACE_VIEW)
	.Add(F_BAR,"ToHTML","Service","  HTML","","Do ToHTML",IMG_HTML,"   HTML ",1,FACE_VIEW)
	.Add(F_BAR,"QReport","Service"," ","","Do QReport",IMG_REPWIZ,"  ",1,FACE_VIEW)
	
	.Add(F_BAR,"SSP1","Service","\-",,,,,1)
	
	.Add(F_BAR,"Calc","Service","\<","","Do RunCalc",IMG_CALC," ",1,FACE_FREE)
	
	.Add(F_BAR,"SSP9","Service","\-",,,,,1)
	
	.Add(F_BAR,"Setup","Service","\<","","oKernel.Setup.Set()",IMG_SETUP," ")
	
	***** Report
	
*	.Add(F_PAD,"PadReport","_MSYSMENU","\<","Alt+J",,,"    ")
*	.Add(F_POP,"Reports","PadReport")
	
	***** Window
	
	.Add(F_PAD,"PadWindow","_MSYSMENU","\<","Alt+R",,,"  ")
	.Add(F_POP,"_MWINDOW","PadWindow")
	
	.Add(F_BAR,"NextWindow","_MWINDOW"," ","Ctrl+F6",_MWI_ROTAT,_MWI_ROTAT,"   ")
	.Add(F_BAR,"WSP1","_MWINDOW","\-",,_MWI_SP100)
	.Add(F_BAR,"ArrangeWindow","_MWINDOW","\< ","",_MWI_ARRAN,_MWI_ARRAN,"          ")
	.Add(F_BAR,"CascadeWindow","_MWINDOW","\< ","",_MWI_CASCADE,_MWI_CASCADE,"         ")
	.Add(F_BAR,"WSP2","_MWINDOW","\-",,_MWI_SP200)
	.Add(F_BAR,"ZoomWindow","_MWINDOW"," ","Ctrl+F10",_MWI_ZOOM,_MWI_ZOOM,"/  ")
	
	*****   
	
	.Add(F_BAR,"ViewGrid","View","  ...","","Do Grid",""," ",,FACE_VIEW)
	.Add(F_BAR,"ViewColumn","View","  ...","","Do Column",""," ",,FACE_VIEW)
	
	.Add(F_BAR,"ViewCustID","View","","F6","DoObj([GetCustomer()])",IMG_USER," ",,FACE_20)
	.Add(F_BAR,"ViewData","View","","F7","DoObj([GetData()])",IMG_DATA,"  ",,Bitor(FACE_20,FACE_40))
	.Add(F_BAR,"ViewOption","View"," ","","DoObj([GetOption()])",IMG_W4,"  ",,Bitor(FACE_20,FACE_40))
	
	.Add(F_BAR,"VW100","View","\-",,,,,0,Bitor(FACE_10,FACE_20))
	
	.Add(F_BAR,"ViewOwner","View","","","DoObj([GetOwner()])",IMG_OWNER," ",,FACE_20)
	
	.Add(F_BAR,"VW900","View","\-",,,,,0,Bitor(FACE_10,FACE_20))
	
	.Add(F_BAR,"ViewNote","View","","","Do Note",IMG_NOTE,"  ",,FACE_10)
	
	
	*****
	
	.Show()

EndWith


*:********************************************************************
*:
*:    Class : InterFace based on Custom
*:
*:********************************************************************
Define Class InterFace as Custom
	PopupCount=0
	Dimension aPopup[1]
	Lock=.F.
	State=0
	
	*:********************************************************************
	*:
	*: Method : Add of class InterFace
	*:
	*:********************************************************************
	Procedure Add(nType,cName,cParent,cPrompt,cKey,xCommand,xPicture,cStatus,lTool,StateMask)
	With this
		Local o
		.AddObject(cName,"Face")
		o=Evaluate('.'+cName)
		With o
			.Type=nType
			.ParentName=cParent
			.Prompt=Iif(Vartype(cPrompt)='C',cPrompt,"")
			.Command=Iif(InList(Vartype(xCommand),"C","N"),xCommand,.null.)
			.Picture=Iif(Vartype(xPicture)="C",xPicture,"")
			.Pictres=Iif(Vartype(xPicture)="N",xPicture,0)
			.StatusBarText=Iif(Vartype(cStatus)="C",cStatus," ")
			.ToolTipText=Iif(Vartype(cPrompt)="C",Chrtran(cPrompt,"\<|",""),"")
			.ToolBar=not Empty(lTool)
			.Key=Iif(Vartype(cKey)="C",cKey,"")
			.Mask=Iif(Vartype(StateMask)='N',StateMask,0)
		EndWith
		Return o
	EndWith
	
	*:********************************************************************
	*:
	*: Method : Init of class InterFace
	*:
	*:********************************************************************
	Procedure Init
	Push Menu _MSYSMENU
	
	*:********************************************************************
	*:
	*: Method : Show of class InterFace
	*:
	*:********************************************************************
	Procedure Show(cPopup)
	With this
		If .Lock
			Return .T.
		EndIf
		
		_Screen.LockScreen= .T.
		
		If Empty(cPopup)
			Set Sysmenu To 
		Else
			Release Bar All of &cPopup
		EndIf
		
		Local o,s,pop,menu,msg,cStr, cPrompt
		
		For each o in .Controls
			If o.baseclass='ToolBar'
				Loop
			EndIf
			
			If not Empty(cPopup) 
				
				If Upper(o.Popup)==Upper(cPopup)
				Else
					Loop
				EndIf
			EndIf
			
			With o
				If .Visible
					DO case
					Case Bitand(.Type,F_PAD)=F_PAD
						s=Iif(Empty(.Key),"",'KEY '+.Key+',"'+.Key+'"')
						If not Empty(.Skip)
							s=s+" SKIP FOR "+.Skip
						EndIf
						
						m.menu=.ParentName
						If Left(m.menu,1)='_'
						Else
							m.menu=m.menu
						EndIf
						
						If o.Enable
							cPrompt=.Prompt
						Else
							cPrompt='\'+.Prompt
						EndIf
						
						Define Pad (.Name) of &Menu Prompt (.Prompt) &s
						
					Case Bitand(.Type,F_POP)=F_POP
						s=""
						If not Empty(.Skip)
							s=s+" SKIP FOR "+.Skip
						EndIf
						m.pop=.Name
						.Popup=m.pop
						Define Popup &Pop Margin relative &s
						
						Local gp
						gp=Evaluate('this.'+.ParentName)
						DO case
						case gp.Type=F_PAD
							m.sysmenu=gp.ParentName
							m.padname=gp.name
							On Pad &padname of &sysmenu activate Popup &pop
						case gp.Type=F_BAR
							m.sysmenu=gp.ParentName
							m.padname=gp.name
							On Bar (gp.Bar) of &sysmenu activate Popup &pop
						EndCase
					Case Bitand(.Type,F_BAR)=F_BAR
						s=Iif(Empty(.Key),"",'KEY '+.Key+',"'+.Key+'"')
						If not Empty(.Skip)
							s=s+" SKIP FOR "+.Skip
						EndIf
						If not Empty(.Pictres)
							s=s+" PICTRES "+Ltrim(Str(.Pictres))
						EndIf
						If not empty(.Picture) and File(.Picture)
							s=s+" PICTURE ["+.Picture+"]"
						EndIf
						If .Invert
							s=s+" INVERT"
						EndIf
						
						m.pop=.ParentName
						
						If Vartype(.Command)="N"
							.Bar=.Command
						Else
							.Bar=this.FreeBar(m.pop)
						EndIf
						
						If o.Enable
							cPrompt=.Prompt
						Else
							cPrompt='\'+.Prompt
						EndIf
						
						.Popup=m.pop
						m.msg=.StatusBarText
						
						*? pop,.bar,.Prompt,s
						
						Define Bar (.Bar) of &pop Prompt (cPrompt) &s Message(m.msg)
						
						If Vartype(.Command)='N' and .Command < 0
						Else
							s='['+.Name+']'
							On Selection Bar (.Bar) of &pop Do MainMenu with &s
						EndIf
						
					EndCase
				EndIf
			EndWith
			If o.ToolBar
				If Vartype(.ToolBar) # "O"
					.AddObject("ToolBar","MyToolBar")
				EndIf
				If o.Prompt="\-" or o.Prompt="\|"
					If not Type('.ToolBar.'+o.Name)="O" 
						.ToolBar.AddObject(o.Name,"MySep")
					EndIf 
				Else
					If Type('.ToolBar.'+o.Name) # "O" and Type('.ToolBar.'+o.Name)#"O"
						.ToolBar.AddObject(o.Name,"ToolBarButton")
					EndIf
					r=Evaluate(".TOOLBAR."+o.NAme)
					With r
						.Visible=o.Visible
						.Command=o.Command
						.StatusBarText=o.StatusBarText
						.ToolTipText=o.ToolTipText
						If Vartype(o.Picture)='C' and File(o.Picture)
							.Picture=o.Picture
						EndIf
					EndWith
				EndIf
			EndIf
		Next
		If Vartype(.ToolBar) = "O"
			If not .ToolBar.Visible
				With .ToolBar
					.Dock(0)
					.Visible=.T.
				EndWith
			EndIf
		EndIf
		
		_Screen.LockScreen= .F.
		
	EndWith
	
	*:********************************************************************
	*:
	*: Method : Destroy of class InterFace
	*:
	*:********************************************************************
	Procedure Destroy
	Pop Menu _MSYSMENU to MASTER
	
	*:********************************************************************
	*:
	*: Method : FreeBar of class InterFace
	*:
	*:********************************************************************
	Procedure FreeBar(popup)
	With this
		If not Popup(popup)
			Return 1
		EndIf
		Local ret,i,k
		ret=200
		For i=1 to Cntbar(popup)
			Ret=Max(Getbar(popup,i),ret)
		Next
		ret = ret + 1 
		Return ret
	EndWith
	
	*:********************************************************************
	*:
	*: Method : SetState of class InterFace
	*:
	*:********************************************************************
	Procedure SetState(lViewEnable)
	*         
	lViewEnable=Iif(not Empty(lViewEnable),.T.,.F.)
	
	With this
		Local o
		For each o in .Controls
			If o.class='Face' and not o.Popup='VIEW'
				If not Empty(o.mask)
					o.Enable=Bitand(.State,o.Mask)>0 and not Bitand(.State,FACE_MODAL)=FACE_MODAL
				EndIf
			EndIf
		Next

		*   - 
		
		.Lock=.T.		
		
		For each o in .Controls
			If o.class='Face' and o.Popup='VIEW'
				If not Empty(o.mask)
					o.Visible=Bitand(.State,o.Mask)=o.Mask 
				EndIf
			EndIf
		Next
		
		.Lock=.F.
		.Show('View')
		
	EndWith
	
	
EndDefine

*:********************************************************************
*:
*:    Class : Face based on Custom
*:
*:********************************************************************
Define Class Face as Custom
	Popup=""			&& Popup menu name
	Prompt=""			&& Menu Prompt
	Picture=""			&& Picture of PictRes
	Pictres=0
	Command=.null.		&& Command as OPCODE or command line
	StatusBarText=" "	&& 
	ToolTipText=" "
	ToolBar=.F.			&& Make a ToolBar
	Key=""				&& Hoke key combination
	Bar=0				&& Popup Bar number
	Enable=.T.			&& Enable or disable
	Check=.F.			&& Check or un Check
	Visible=.T.			&& Build or skip
	Skip=""				&& SKOP FOR Expression
	Invert=.F.			&& Invert bar style
	FontName=""			&& May specified diffrerent font name
	FontStyle=""		&& Font style "BINQ-TU"
	Type=0				&& Pad, Popup, Bar
	ParentName=""		&& Parent object name
	Mask=0				&&     
	
	
	*:********************************************************************
	*:
	*: Method : Click of class Face
	*:
	*:********************************************************************
	Procedure Click
	With this
		if not empty(.Command) 
			If vartype(.Command)='N' and vartype(ROOT_OBJECT)=T_OBJECT
				ROOT_OBJECT.Shell(.Command)
			EndIf
			If Vartype(.Command)="C"
				local CommandLine
				CommandLine=.Command
				&CommandLine
			EndIf
		EndIf 
	EndWith 
	
	*:********************************************************************
	*:
	*: Method : Enable_Assign of class Face
	*:
	*:********************************************************************
	Procedure Enable_Assign(lValue)
	With this
		.Enable=lValue
		If .Parent.Lock
			Return .T.
		EndIf
		If .Type=F_BAR
			Local pop
			pop=.Popup
			Set Skip of Bar (.Bar) of &pop (not .Enable)
		EndIf
		If .Type=F_PAD
			Set Skip of Pad (.Name) of _MSYSMENU (not .Enable)
		EndIf
		If .ToolBar
			Local o
			o=Evaluate('.parent.toolbar.'+.name)
			o.Enabled=.Enable
		EndIf
	EndWith
	
	*:********************************************************************
	*:
	*: Method : Check_Assign of class Face
	*:
	*:********************************************************************
	Procedure Check_Assign(lValue)
	With this
		.Check=lValue
		If .Parent.Lock
			Return .T.
		EndIf
		If .Type=F_BAR
			Local pop
			pop=.Popup
			Set Mark of Bar (.Bar) of &pop (.Check)
		EndIf
		If .ToolBar
			Local o
			o=Evaluate('.parent.toolbar.'+.name)
			If o.baseclass='CheckBox'
				o.Value=.Check
			EndIf
		EndIf
	EndWith
	
	*:********************************************************************
	*:
	*: Method : Invert_Assign of class Face
	*:
	*:********************************************************************
	Procedure Invert_Assign(lValue)
	With this
		.Invert=lValue
		If .Parent.Lock
			Return .T.
		EndIf
		If .Type=F_BAR
			.Parent.Show(.Popup)
		EndIf
		If .ToolBar
			Local o
			o=Evaluate('.parent.toolbar.'+.name)
			If o.baseclass='CheckBox'
				o.Value=.Invert
			EndIf
		EndIf
	EndWith
	
	*:********************************************************************
	*:
	*: Method : Visible_Assign of class Face
	*:
	*:********************************************************************
	Procedure Visible_Assign(lValue)
	With this
		.Visible=lValue
		If .Parent.Lock
			Return .T.
		EndIf
		If .Type=F_BAR
			.Parent.Show(.Popup)
		EndIf
		If .ToolBar
			Local o
			o=Evaluate('.parent.toolbar.'+.name)
			o.Visible=.Visible
		EndIf
	EndWith
EndDefine

*:********************************************************************
*:
*:    Class : ToolBarButton based on CommandButton
*:
*:********************************************************************
Define Class ToolBarButton as CommandButton
	Width=22
	Height=22
	Caption=""
	StatusBarText=""
	ToolTipText=""
	Action=0
	Command=""
	Visible=.T.
	SpecialEffect=2
	StatusBarText=""
	
	*:********************************************************************
	*:
	*: Method : Init of class ToolBarButton
	*:
	*:********************************************************************
	Procedure Init( cPicture, nAction, cToolTip, cStatus)
	with this
		if vartype(cPicture)='C'
			.Picture=cPicture
		endif
		if vartype(nAction)='N'
			.Action=nAction
		endif
		if vartype(nAction)='C'
			.Command=nAction
		endif
		if vartype(cToolTip)='C'
			.ToolTipText=cToolTip
		endif
		if vartype(cStatus)='C'
			.StatusBarText=cStatus
		else
			.StatusBarText=.ToolTipText
		endif
	endwith
	
	*:********************************************************************
	*:
	*: Method : Picture_Assign of class ToolBarButton
	*:
	*:********************************************************************
	Procedure Picture_Assign( cPictureFile )
	with this
		.Picture=cPictureFile
		if not empty(.picture)
			if not file(.picture)
				Picture(this,cPictureFile)
			endif
		endif
	endwith
	
	*:********************************************************************
	*:
	*: Method : Click of class ToolBarButton
	*:
	*:********************************************************************
	Procedure Click
	with this
		if Vartype(.Command)='N' and vartype(ROOT_OBJECT)=T_OBJECT
			ROOT_OBJECT.Shell(.Command)
		else
			if not empty(.Command)
				local CommandLine
				CommandLine=.Command
				&CommandLine
			endif
		endif
	endwith
	
EndDefine


*:********************************************************************
*:
*:    Class : MyToolBar based on ToolBar
*:
*:********************************************************************
Define class MyToolBar as ToolBar
	Caption=' '
	ShowTips=.T.
	DockState=.T.
	Position=0
	Shown=.T.
	ClsID='MyToolBar.1'
	Movable=.F.
	Sizable=.F.
	
	*:********************************************************************
	*:
	*: Method : Enable of class MyToolBar
	*:
	*:********************************************************************
	Procedure Enable
	with this
		.SetAll('Enabled',.T.,'ToolBarButton')
	endwith
	
	*:********************************************************************
	*:
	*: Method : Disable of class MyToolBar
	*:
	*:********************************************************************
	Procedure Disable
	with this
		.SetAll('Enabled',.F.,'ToolBarButton')
	endwith
	
	*:********************************************************************
	*:
	*: Method : Clear of class MyToolBar
	*:
	*:********************************************************************
	Procedure Clear
	with this
		.LockScreen=.T.
		DO while .ControlCount > 0
			If Vartype(.Controls[1])='O'
				.RemoveObject(.Controls[1])
			EndIf
		EndDo
		.LockScreen=.F.
	EndWith 
	
	*:********************************************************************
	*:
	*: Method : Click of class MyToolBar
	*:
	*:********************************************************************
	Procedure Click
	NoDefault
	
	*:********************************************************************
	*:
	*: Method : DblClick of class MyToolBar
	*:
	*:********************************************************************
	Procedure DblClick
	NoDefault
	
EndDefine

*:********************************************************************
*:
*:    Class : MySep based on Separator
*:
*:********************************************************************
Define Class MySep as Separator
	Style=1
	Visible=.T.
EndDefine
*: End of face.prg
