*
*  -    
*
*

#include main.h


Lparameters m.obj
If vartype(m.obj) # T_OBJECT
	MessageBox("   .",64,"")
	Return .F.
EndIf

With m.Obj
	If Empty(.CustID)
		MessageBox("  ",64,.Title)
		Return .F.
	EndIf

	If Vartype(.Form)=T_OBJECT
		.Form.Close()
	EndIf

	Local m.info, tmp[1]
	m.info=Info("   ...")

	Select Name from Customer where CustID=.CustID into array tmp
	.CustomerName=Iif(_TALLY=0,"",Alltrim(TMP[1]))

	If Used(.alias)
		Zap in (.Alias)
	Else
		Create Cursor (.Alias) ;
			(DocID		C(10);
			,Number		i;
			,Date		d;
			,CashType	i;
			,DocType	i;
			,DocName	c(50);
			,TypeOfDoc	c(20);
			,TypeOfCash c(20);
			,InCome		y;
			,OutGo		y;
			,Saldo		y;
			,Alias		c(10);
			,Object		c(20);
			,SortOrder	i;
			,Note		m;
			)
	EndIf
	m.saldo=GetCustomerBalance(.CustID,.DateMin,.OwnerID)
	Insert into (.Alias) (DocName,Saldo) VALUES (" ",m.saldo)

	****   
	
	Select ;
		DOCID;
		,Number;
		,Date;
		,CashType;
		,DocType;
		,'' as DocName ;
		,Total as InCome;
		,'SUPPLY' as Alias;
		,'SUPPLY' as Object;
		,1 as SortOrder ;
		,Note;
		from supply ;
		where CustID=.CustID ;
		and Date between .DateMin and .DateMax ;
		and OwnerID between .MinOwnerID and .MaxOwnerID ;
		and not DocType=SUP_REST ;
		and not Archive ;
		order by 3,2;
		into cursor _
		
	Select (.Alias)
	Append From Dbf("_")
	
	****   
	
	Select ;
		DOCID;
		,Number;
		,Date;
		,CashType;
		,DocType;
		,' ' as DocName ;
		,Total as OutGo;
		,'PAYMENT' as Alias;
		,'PAYMENT' as Object;
		,2 as SortOrder ;
		,Note;
		from payment ;
		where CustID=.CustID ;
		and Date between .DateMin and .DateMax ;
		and OwnerID between .MinOwnerID and .MaxOwnerID ;
		and not Archive ;
		order by 3,2;
		into cursor _
		
	Select (.Alias)
	Append From Dbf("_")


	****  
	
	Select ;
		DOCID;
		,Number;
		,Date;
		,CashType;
		,DocType;
		,'' as DocName ;
		,Total as OutGo;
		,'INVOICE' as Alias;
		,'INVOICE' as Object;
		,3 as SortOrder ;
		,Note;
		from invoice ;
		where CustID=.CustID ;
		and Date between .DateMin and .DateMax ;
		and OwnerID between .MinOwnerID and .MaxOwnerID ;
		and not Archive ;
		order by 3,2;
		into cursor _
		
	Select (.Alias)
	Append From Dbf("_")


	****  
	
	Select ;
		DOCID;
		,Number;
		,Date;
		,CashType;
		,DocType;
		,' ' as DocName ;
		,Total as InCome;
		,'ORDER' as Alias;
		,'ORDER' as Object;
		,4 as SortOrder ;
		,Note;
		from Order ;
		where CustID=.CustID ;
		and Date between .DateMin and .DateMax ;
		and OwnerID between .MinOwnerID and .MaxOwnerID ;
		and not Archive ;
		order by 3,2;
		into cursor _
		
	Select (.Alias)
	Append From Dbf("_")

	Select * from (.Alias) order by date,SortOrder,Number into cursor _

	USE in Select(.Alias)
	USE Dbf("_") Again Exclusive In 0 Alias (.Alias)
	USE in _

	Local m.suptype, m.invtype, m.cbocash
	m.suptype=CreateObject("SUPDOCTYPE")
	m.invtype=CreateObject("INVDOCTYPE")
	m.cbocash=CreateObject("CBOCASHTYPE")
	
	Select (.Alias)
	Go Top
	m.Saldo=Saldo
	Scan All
		m.Saldo=m.Saldo-InCome+OutGo
		Replace Saldo with m.Saldo
		DO case
		Case alias='INVOICE'
			m.invtype.value=DOCTYPE
			m.text=m.invtype.DisplayValue
		Case alias='SUPPLY'
			m.suptype.value=DOCTYPE
			m.text=m.suptype.DisplayValue
		Otherwise
			m.Text=""
		EndCase
		m.TypeOfCash=""
		If not Empty(CashType)
			m.cboCash.Value=CASHTYPE
			m.TypeOfCash=m.cboCash.DisplayValue
		EndIf
		Replace TypeOfDoc with m.Text, TypeOfCash with m.TypeOfCash
	EndScan

	Select sum(income),sum(outgo) from (.Alias) into  array tmp
	If _tally > 0
		Insert into (.alias) (DocName,Income,OutGo,Saldo) Values ;
		('',tmp[1],tmp[2],m.saldo)
	EndIf
	Go top

	If Not .Direct
		.Show()
	EndIf
	
EndWith


Define Class CustomerCard as Report
	Title=' '
	Text="    "
	Alias="CustCard"
	ClsID="CustCard.View.1"
	FormFile="CustCard"
	Direct=.F.
	CustomerName=""

	Procedure Selection
	With this
		If DoDefault()
			DO CustCard with this
		EndIf
	EndWith

	Procedure HookForm(oForm)
	With oForm
		.Group.Visible=.F.
		.Item.Visible=.F.
	EndWith

	Procedure Browse(oGrid)
	With oGrid
		.Parent.Caption=This.Title+' "'+This.CustomerName+'"'
		.AddColumn(1,"Date","")
		.AddColumn(2,"Number","",'@Z'+_PIC_NUMBER)
		.AddColumn(3,"DocName","")
		.AddColumn(4,"TypeOfDoc","")
		.AddColumn(5,"TypeOfCash"," ")
		.AddColumn(6,"InCome","","@Z "+_PIC_SUMMA)
		.AddColumn(7,"OutGo","","@Z "+_PIC_SUMMA)
		.AddColumn(8,"Saldo","","@Z "+_PIC_SUMMA)
		.AddColumn(9,"(Note)","")

		.Columns[8].DynamicForeColor="Iif(Saldo<0,Rgb(255,0,0),This.ForeColor)"
		.SetAll("DynamicFontBold","iif(DocName=[],.T.,.F.)","MyColumn")

	EndWith

	Procedure Open
	With this
		Local m.docid, m.object
		m.docid=docid
		If not Empty(m.docid)
			m.object=Alltrim(object)
			If not Empty(m.object)
				Return Evaluate("oKernel."+m.Object+".Open(["+m.docid+"])")
			EndIf			
		EndIf
	EndWith
	
EndDefine
	

