*:********************************************************************
*:
*: Procedure file :EXEC.PRG
*:
*: (c) Piva, BEAR v.42 on 07.02.2003 15:27
*:********************************************************************
*
*   EXEC
*
*   .. 2001, 
* piva@kurgan.isp.ru
*
* 14:00, , 27  2001 .


#define MY_NAME		"  .."
#define MY_MAIL		"piva@acmetelecom.ru"
#define MY_INI		"C:\WORK\EXEC.INI"
#define VFP7		Version(5)>=700

Self=SYS(16)

***** Environment

Define Popup ExecEnv margin relative shortcut 
Define Bar  1 of ExecEnv Prompt 'Insert DateTime'	key Ctrl+T,'^T'
Define Bar  2 of ExecEnv Prompt 'Insert Copyright'	key Ctrl+Q,'^Q'
Define Bar  3 of ExecEnv Prompt 'Inline commentt'	key Ctrl+H,'^H'


Define Bar 10 of ExecEnv Prompt '\-'

Define Bar 11 of ExecEnv Prompt 'Format Objects' 	key Ctrl+0,'Ctrl 0'
Define Bar 12 of ExecEnv Prompt 'Format Object'		key Ctrl+BACKSLASH,"Ctrl \"
Define Bar 15 of ExecEnv Prompt 'Dialog Form'		

Define Bar 13 of ExecEnv Prompt '\-'

Define Bar 14 of ExecEnv Prompt 'Insert DFC entry'	key Alt+?,'Alt+?'

on selection popup ExecEnv do ExecEnv with Prompt(),Bar() in &Self

*** OpenFiles

Define Popup ExecOpenFiles margin relative
Define Bar  1 of ExecOpenFiles Prompt 'Modify Project'		key alt+1,'Alt 1'
Define Bar  2 of ExecOpenFiles Prompt 'Modify Report'		key alt+2,'Alt 2'
Define Bar  3 of ExecOpenFiles Prompt 'Modify File'			key alt+3,'Alt 3'
Define Bar  4 of ExecOpenFiles Prompt 'Modify Command'		key alt+4,'Alt 4'
Define Bar  5 of ExecOpenFiles Prompt 'Modify Form'			key alt+5,'Alt 5'
Define Bar  6 of ExecOpenFiles Prompt 'Modify Menu'			key alt+6,'Alt 6'
Define Bar  7 of ExecOpenFiles Prompt 'Modify Class'		key alt+7,'Alt 7'
Define Bar  8 of ExecOpenFiles Prompt 'Modify Query'		key alt+8,'Alt 8'
Define Bar  9 of ExecOpenFiles Prompt 'Modify DataBase'		key alt+9,'Alt 9'
Define Bar 10 of ExecOpenFiles Prompt 'Modify Procedures'	key alt+0,'Alt 0'

Define Bar 11 of ExecOpenFiles Prompt 'Open Project' 		key F5,'F5'
Define Bar 12 of ExecOpenFiles Prompt 'Open Class'			key F6,'F7'
Define Bar 13 of ExecOpenFiles Prompt 'Open Procedure'		key F8,'F8'
Define Bar 14 of ExecOpenFiles Prompt 'Open DataBase'		key F11,'F11'

On Selection Popup ExecOpenFiles do ExecOpenFiles with Prompt(),Bar() in &Self

*** System

Define Popup ExecSystem margin relative
Define Bar  1 of ExecSystem Prompt 'Browse' 	key F3,'F3'
Define Bar  2 of ExecSystem Prompt 'Set' 		key F2,'F2'
Define Bar  3 of ExecSystem Prompt 'Current Dir' key Alt+F2,'Alt F2'
Define Bar  4 of ExecSystem Prompt '\-'
Define Bar  _MPR_CANCL 		of ExecSystem Prompt 'Cancel' 
Define Bar  _MPR_RESUM 		of ExecSystem Prompt 'Resume' key Ctrl+M,'^M'
Define Bar  _MPR_SUSPEND	of ExecSystem Prompt 'Suspend'
Define Bar  9 of ExecSystem Prompt '\-'
Define Bar  10 of ExecSystem Prompt 'XA'

On Selection Popup ExecSystem do ExecSystem with Prompt(),Bar() in &Self

**** Tools

Define Popup ExecTools margin relative
Define Bar  1 of ExecTools 	Prompt 'Database GenDBC'
Define Bar  2 of ExecTools  Prompt 'Beautify by Bear' key CTRL+K,'^K'
Define Bar  3 of ExecTools  Prompt 'Calculator' key ALT+EQUALS,'Alt ='
Define Bar  4 of ExecTools  Prompt 'Spell Check' key CTRL+Y,"^Y"
Define Bar  5 of ExecTools  Prompt 'Field Helper' key F9,"F9"
Define Bar  6 of ExecTools  Prompt 'Inline Comment' key Alt+N,"Alt+N"


On Selection Bar 1 of ExecTools do Home()+"TOOLS\GENDBC\GENDBC.PRG"
On Selection Bar 2 of ExecTools do "c:\work\bear"
On Selection Bar 3 of ExecTools run /n calc.exe
On Selection Bar 4 of ExecTools do "C:\VFP7\MYSPELL.PRG" 
On Selection Bar 5 of ExecTools do "C:\VFP7\INTR.PRG" 
On Selection Bar 6 of ExecTools do "c:\work\inline"

**** Exec popup

Define Popup Exec margin relative
Define Bar 1 of Exec Prompt 'Change directory'

Define Bar 2 of Exec prompt '\-'

Define Bar 3 of Exec prompt 'Environment '
Define Bar 4 of Exec prompt 'Open files '
Define Bar 5 of Exec prompt 'System commands '
Define Bar 6 of Exec prompt 'Tools '
Define Bar 99 of Exec Prompt '\-'
Define Bar 100 of Exec Prompt 'Remove Exec pad'

on selection bar 1 of Exec do CDir in &Self

on bar 3 of Exec Activate popup ExecEnv
on bar 4 of Exec Activate popup ExecOpenFiles
on bar 5 of Exec Activate popup ExecSystem
on bar 6 of Exec Activate popup ExecTools

on selection bar 100 of Exec do Uninstall in &Self

Define Pad Exec of _MSYSMENU prompt 'E\<xec' key alt+x
On Pad Exec of _MSYSMENU activate popup Exec 

Do ReadProjects in &Self

*:********************************************************************
*:
*: Procedure : READPROJECTS
*:
*:********************************************************************
Procedure ReadProjects

*   EXEC.INI   
*  VISUAL (     FPW  FPD )
* [Visual]
* ; =  
* Remote SQL test=C:\Work\Visual\SQL
*

if not VFP7
	If not 'FOXTOOLS.FLL' $ set('libr')
		set library to (Home()+'FOXTOOLS.FLL') additive
	EndIf
EndIf

declare integer GetPrivateProfileString in Win32Api ;
	STRING cSection,;
	STRING cItem,;
	STRING cDefault,;
	STRING @ buffer,;
	INTEGER buflength,;
	STRING cIniFile


local j, k, buffer, ret, m.name, m.dir, m.inifile
m.inifile=MY_INI
buffer=repl(chr(0),4096)
j=9
k=0
k=k+1
ret=GetPrivateProfileString("Visual",0,"",@buffer, len(buffer),m.inifile)
if ret = 0
	exit
endif
m.buffer=chrtran(left(m.buffer, ret),chr(0),chr(1))
for i=1 to GetWordCount(m.buffer,chr(1))
	m.name=GetWordNum(m.buffer, i, chr(1))
	m.buf=repl(chr(0),128)
	ret=GetPrivateProfileString("Visual",m.name,"",@buf, len(buf),m.inifile)
	m.dir=left(buf,ret)
	
	
	if ADIR(TMP,m.dir,'D')=1
		if j=9
			Define bar 9 of Exec Prompt '\-' before 99
		endif
		
		j=j+1
		
		s='"'+m.dir+'"'
		ico=Addbs(m.dir)+"main.bmp"
		If File(m.ico)
			ico='"'+Addbs(m.dir)+"main.bmp"+'"'
			define bar (j) of Exec prompt (m.name) style 'B' after j-1 picture &ico message m.dir
		Else
			define bar (j) of Exec prompt (m.name) style 'B' after j-1 message m.dir
		EndIf
		on selection bar (j) of Exec do cd with &s in &Self
	endif
next

m.buf=repl(chr(0),128)
ret=GetPrivateProfileString("Last",Transform(Version(5),'9999'),"",@buf, len(buf),m.inifile)
if ret > 0
	do cd with left(m.buf, ret) 
endif

*:********************************************************************
*:
*: Procedure : CD
*:
*:********************************************************************
procedure cd( dir )
*   

if rat('\',dir)#len(dir)
	dir=dir+'\'
endif
if not directory(dir)
	wait window nowait 'CD: Invalid path'
	return
endif
set default to (dir)
wait window nowait "Entering :"+dir

declare integer WritePrivateProfileString in Win32Api ;
	STRING cSection,;
	STRING cItem,;
	STRING cString,;
	STRING cIniFile

WritePrivateProfileString("Last",Transform(Version(5),'9999'),dir,MY_INI)

Do ThisAutoExec

*:********************************************************************
*:
*: Procedure : EXECOPENFILES
*:
*:********************************************************************
Procedure ExecOpenFiles( cPrompt, nBar )
do case
case cPrompt='Modify'
	Local _clip
	_clip=_cliptext
	_cliptext=cPrompt
	activate window command
	Sys(1500,'_MED_PASTE','_MEDIT')
	DoEvents
	_cliptext=_clip
	Keyboard ' ' plain
case cPrompt='Open'
	local m.file, tmp[1]
	do case 
	case atc('PROJECT',cPrompt)>0
		m.file=OpenFileEx("PJX")
		If not Empty(m.file)
			Modify Project (m.file) nowait
		EndIf 
	case atc('CLASS',cPrompt)>0
		if aGetClass(tmp) 
			modify class (tmp[2]) of (tmp[1])
		endif
	case atc('PROCEDURE',cPrompt)>0
		if empty(dbc())
			if aDataBase(tmp)=1
				set database to (tmp[1])
			else
				m.file=OpenFileEx('DBC')
				if not empty(m.file)
					open database (m.file)
				else
					Return .F.
				endif
			endif
		endif
		modify procedure
	case atc('DATABASE',cPrompt)>0
		if empty(dbc())
			if aDataBase(tmp)=1
				set database to (tmp[1])
			else
				m.file=OpenFileEx('DBC')
				if not empty(m.file)
					open database (m.file)
				else
					Return .F.
				endif
			endif
		endif		
		modify database 
	endcase
endcase	


*:********************************************************************
*:
*: Procedure : EXECENV
*:
*:********************************************************************
Procedure ExecEnv( cPrompt, nBar )
do case
case nBar=1
	keyboard Left(Time(),5)+", "+TRAN(DATE(),'@YL') plain 
case nBar=2
	keyboard MY_NAME+" "+Tran(Year(DATE()))+", "+MY_MAIL plain

case nBar=3
	keyboard "	"+Chr(38)+Chr(38)+" " plain
	
case inlist(nBar,4,5,6)
	do Header with nBar-3 in (Home()+"EDITOR")
case inlist(nBar,8,9)
	do XCase with nBar=9 in (Home()+"EDITOR")
	
case nBar=11
	do ("C:\VFP7\format")
case nBar=12
	do form ("C:\VFP7\format")
case nBar=15
	do ("C:\VFP7\form")
case nBar=14
	keyboard ;
		'parameter m.__'+'{ENTER}'+;
		"if type('m.__')='C'"+'{ENTER}'+'{TAB}'+;
		"return eval(m.__)"+'{ENTER}{BACKSPACE}'+;
		"endif"+'{ENTER}' plain clear
	
endcase

*:********************************************************************
*:
*: Procedure : EXECSYSTEM
*:
*:********************************************************************
Procedure ExecSystem( cPrompt, nBar )
do case
case nBar=1
	Do BrowseNormal 
case nBar=2
	SET
case nBar=3
	Wait Window NoWait Full('.')
	
case nBar=10
	clear all
	close all
	clear program
	clear resource
	on key
endcase		


*:********************************************************************
*:
*: Procedure : OPENFILEEX
*:
*:********************************************************************
Procedure OpenFileEx( m.Ext)
*    -   
*     -   

local tmp[1]
if ADIR(tmp,'*.'+m.Ext)=1
	Return tmp[1]	
else
	Return GetFile(m.Ext)
endif

*:********************************************************************
*:
*: Procedure : BROWSENORMAL
*:
*:********************************************************************
Procedure BrowseNormal
if empty(used())
	local i,k, r, c
	define popup Brow margin shadow shortcut title ' Browse Alias '
	k=0
	for i=1 to sele(1)
		if used(i)
			k=k+1
			define bar k of Brow prompt alias(i)
		endif
	next
	do case
	case k = 1
		select (prmbar("Brow",1))
	case k > 1
		on selection popup Brow deactivate popup
		c=scol()/2-7
		if cntbar("BROW") > srow()-2
			r=1
		else
			r=(srow()-cntbar("BROW"))/2
		endif
		activate popup Brow at r,c
		if empty(prompt())
			return .f.
		endif
		select (prompt())
	other
		rele popup Brow exten
		select 0
		use ?
		if not used()
			return .f.
		endif
	endcase
	rele popup Brow exten
endif		

BROWSE NORMAL NOWAIT


*:********************************************************************
*:
*: Procedure : CDIR
*:
*:********************************************************************
Procedure CDir

local m.path
m.path=full('.')
if not VFP7 and 'MKFOX.FLL' $ SET('LIBR')
	m.path=U_SHBrowse('Where Go ?',0x0001,m.path)
else
	If VFP7
		m.path=GetDir(m.path,'Where go ?',"",1)
	else
		m.path=GetDir(m.path,'Where go ?')
	endif
endif
if !empty(m.path)
	set default to (m.path)
	do ThisAutoExec
endif


*:********************************************************************
*:
*: Procedure : THISAUTOEXEC
*:
*:********************************************************************
Procedure ThisAutoExec
if file(full('')+'autoexec.prg')
	do (full('')+'autoexec.prg')
endif


*:********************************************************************
*:
*: Procedure : UNINSTALL
*:
*:********************************************************************
procedure UnInstall
local count
FOR count = 1 TO CNTPAD('_msysmenu')  && Number of pads
	IF PRMPAD('_msysmenu', GETPAD('_msysmenu', count)) = 'Exec'
		RELEASE PAD (GETPAD('_msysmenu', count)) OF _msysmenu
		RELEASE POPUP EXEC EXTENDED
		EXIT
	ENDIF
ENDFOR

#IF Version(5)<700
	
*:********************************************************************
*:
*: Procedure : GETWORDNUM
*:
*:********************************************************************
Procedure GetWordNum(cString,nIndex,cDelimiter)
Return WordNum(cString,nIndex,cDelimiter)

*:********************************************************************
*:
*: Procedure : GETWORDCOUNT
*:
*:********************************************************************
Procedure GetWordCount(cString,cDelimiter)
Return Words(cString,cDelimiter)

#Endif 

*: End of EXEC.PRG
