*:********************************************************************
*:
*: Procedure file :zing.prg
*:
*: (c) Piva, BEAR v.43 on 10.10.2003 15:14
*:********************************************************************
*  
*****************************************************************
*      ,
*       
* (c)  .. 1995 .
* ( 2.     ...)
* FoxTools.FLL -   FLL'     
*****************************************************************
* :
*  : -  1995
*   1995.  BMP    
*  26.12.95 22:00	  _ASSIST 
*					    AUTOEXEC.PRG
*  27.12.95 21:48	   VUE 
*  24.05.98 22:16	     VCX 
*						  EXE  RECOMPILE
*
******************************************************************
#Define c_self         	ZING
#Define Self			ZING
#Define selffxp			"Zing.FXP"
#Define BMP_Exclude		.F.
#Define fExcluded		.F.

*--- Bar numbers

#Define br_pops     0		&& distance of arrayrow and bar number
#Define br_prog     1
#Define br_screen   2
#Define br_class    3
#Define br_menu     4
#Define br_report   5
#Define br_base     6
#Define br_file     7
#Define br_txt      8
#Define br_bmp      9
#Define br_sep1     20
#Define br_reload   21
#Define br_sep2     22
#Define br_build	23
#Define br_buildexe 24
#Define br_Run		25
#Define br_Open		26
#Define br_Errs		27
#Define br_sep3     28
#Define br_buildapp 29
#Define br_sep4     30
#Define br_close    99


#Define br_skipto    0		&& same as br_pops

*--- array rows as br_pops + p_xxxx

#Define p_prog      1		&& 
#Define p_screen    2		&& 
#Define p_class		3		&& 
#Define p_menu      4		&& 
#Define p_report    5		&& 
#Define p_base      6		&& 
#Define p_file      7		&&  
#Define p_text      8		&&  
#Define p_bmp		9		&& BMP'

*--- Project file types

#Define typ_hdr     "H"
#Define typ_prg     "P"
#Define typ_form    "K"
#Define typ_scx     "s"
#Define typ_spr     "S"
#Define typ_mnx     "M"
#Define typ_frx     "R"
#Define typ_dbf     "D"
#Define typ_dbc     "d"
#Define typ_xxx     "x"
#Define typ_app     "Z"
#Define typ_exe     "Z"
#Define typ_lib     "L"
#Define typ_idx     "I"
#Define typ_txt     "T"
#Define typ_vcx     "V"
#Define typ_wrong   " "

*--- Using File Extensions ---

#Define ext_Project "PJX"
#Define ext_Error   "ERR"
#Define ext_Bitmap	"BMP"
#Define ext_View	"VUE"

*--- Autoexec.prg

#Define autoexec    "autoexec.prg"

*--- Hot keys

#Define hk_Reload   ctrl+I,"^I"
#Define hk_Run      ctrl+W,"^W"
#Define hk_Build    ctrl+E,"^E"
#Define hk_Open     ctrl+O,"^O"
#Define hk_Error    ctrl+S,"^S"

*-----------------------------------------------------

Lparameters m.prjfile
Private I, m.lconnect, tmp

If _Assist="Zing"		&& Prevent of recursive CALL
	Wait Window Nowait "Already Zing'ed"
	Return .F.
Endif

_Assist="Zing"

If Empty(m.prjfile)
	If Adir(tmp,"*."+ext_Project)=1              &&     
		m.prjfile=tmp[1,1]              &&   
	Else
		m.prjfile=Getfile(ext_Project," ")   &&   
		If Empty(m.prjfile)
			Do done In Self
			Return
		Endif
	Endif
Else
	m.prjfile=Forceext(m.prjfile,ext_Project) &&   .PJX
Endif
m.prjfile=Fullpath(m.prjfile)           &&   
If Not File(m.prjfile)                  &&  -  
	Messagebox(" "+m.prjfile+"  .","",16)    &&  
	Do done In Self                     &&  
	Return
Endif

Do reload With m.prjfile                &&  ...

*:********************************************************************
*:
*: Procedure : reload
*:
*:********************************************************************
Procedure reload
Parameter m.prj

=Say('  ...')

Release Popup ZING Extended             &&    

m.self=Getwordnum(Sys(16), Iif( Getwordcount( Sys(16) )>1,3,1))

m.errfile='"'+Addbs(Justpath(m.prj))+Juststem(m.prj)+'.err'+'"'

If Not Empty(autoexec) And File(Sys(5)+Curdir()+"autoexec")
	Do (Sys(5)+Curdir()+"autoexec") &&  
Endif

Define Pad ZING Of _Msysmenu Prompt '\<Zing' ;
	KEY Alt+z Color Scheme 3
Define Popup ZING Shadow Margin Relative Color Scheme 4

Define Bar br_buildexe  Of ZING Prompt ' \<EXE' Key hk_Build Picture "C:\Work\Common\Images\Build2.bmp"
Define Bar br_build     Of ZING Prompt ' \<' Picture "C:\Work\Common\Images\Build1.bmp"
Define Bar br_Run		Of ZING Prompt '\< ' Key hk_Run pictres _Mpr_do
Define Bar br_Open		Of ZING Prompt '\<  ' Picture "C:\Work\Common\Images\Ide.bmp"
Define Bar br_Errs		Of ZING Prompt ' \<' Key hk_Error ;
	Skip For Not File(&errfile)
Define Bar br_sep4      Of ZING Prompt '\-'
Define Bar br_close     Of ZING Prompt ' '+m.prj

m.str='"'+m.prj+'"'                     &&   
*      -  

On Pad ZING Of _Msysmenu Activate Popup ZING
On Selection Bar br_build		Of ZING Do Build In &Self
On Selection Bar br_buildexe	Of ZING Do Build In &Self With .T.
On Selection Bar br_Run			Of ZING Do Run In &Self
On Selection Bar br_Open		Of ZING Modify Project &Str Nowait
On Selection Bar br_close		Of ZING Do Close In &Self
On Selection Bar br_Errs 		Of ZING Modify File &errfile Nowait Noedit

=Say('  '+m.prj+' .' )
Do done In &Self

*:********************************************************************
*:
*: Procedure : Build
*:
*:********************************************************************
Procedure Build
Lparameter m.lMakeEXE
_Wrap=!Empty(m.lMakeEXE)
* WRAP AROUND CLEAR ALL
Clear All
m.lMakeEXE=_Wrap
Private m.prj, m.app, m.name, k,j, m.S
m.prj=Alltrim(Substr(Prmbar("Zing",br_close),8))
m.app=Substr(m.prj,1,Rat('.',m.prj))+Iif(m.lMakeEXE,'EXE','APP')
If Not File(m.app)
	m.app=Putfile(" ",m.app,Iif(m.lMakeEXE,"EXE","APP"))
	If Empty(m.app)
		=Messagebox("    !",16,'Zing 3')
		Return .F.
	Endif
Endif

k=Rat('\',Fullpath(m.app))
j=Rat('.',Fullpath(m.app))
m.S=Fullpath(selffxp)
m.name=Substr(Fullpath(m.app),k+1,j-k-1)

If Not (m.app $ Prmbar("Zing",br_build))
Endif

Wait Window Nowait "Build "+m.app

If m.lMakeEXE
	Build Exe (m.app) From (m.prj) &&RECOMPILE
Else
	Build App (m.app) From (m.prj)
Endif
If File(m.name+'.ERR')
	Modify File (m.name+'.ERR') Nowait
Endif

Local hFile, nFileSize
Set Comp On
nFileSize=Fsize(m.app)
Set Comp Off
Set Message To '  '+Justfname(m.app)+' = '+Ltrim(Tran(nFileSize,'999 999 999 999'))+' .')

Wait Clear

*:********************************************************************
*:
*: Procedure : Run
*:
*:********************************************************************
Procedure Run
Private m.app
m.app=Alltrim(Substr(Prmbar("Zing",br_close),8))
m.app=Substr(m.app,1,Rat('.',m.app))+'APP'

If File(m.app)
	Do (m.app)
Else
	m.app=Substr(m.app,1,Rat('.',m.app))+'EXE'
	If File(m.app)
		Do (m.app)
	Else
		?? Chr(7)
		Wait Window Nowait '  '+m.app
	Endif
Endif

*:********************************************************************
*:
*: Procedure : done
*:
*:********************************************************************
Procedure done
_Assist=""


*:********************************************************************
*:
*: Procedure : Close
*:
*:********************************************************************
Procedure Close
Release Popup ZING Extended
Release Pad ZING Of _Msysmenu

*:********************************************************************
*:
*: Procedure : Say
*:
*:********************************************************************
Procedure Say
Parameter m.txt

If _Windows And Set('STATUS BAR')='ON'
	Set Message To m.txt
Else
	Wait Window Nowait m.txt
Endif

*: End of zing.prg
